MODULE TestPT3IM2;
IMPORT Asm, B := Basic, PT3x0A, B40 := Best40;

VAR
  ace: PT3x0A.Melody; udg: INTEGER;

  PROCEDURE ProcIM2;
  BEGIN
    Asm.Code("EX   AF,AF");
    Asm.Code("EXX       ");
    Asm.Code("PUSH AF   ");
    Asm.Code("PUSH BC   ");
    Asm.Code("PUSH DE   ");
    Asm.Code("PUSH HL   ");
    PT3x0A.Play;
    Asm.Code("LD   IY,#0x5C3A");
    Asm.Code("RST  0x38 ");
    Asm.Code("POP  HL   ");
    Asm.Code("POP  DE   ");
    Asm.Code("POP  BC   ");
    Asm.Code("POP  AF   ");
    Asm.Code("EXX       ");
    Asm.Code("EX   AF,AF");
    Asm.Code("EI");
  END ProcIM2;

PROCEDURE Best40Test;
VAR
	i: SHORTINT;
BEGIN
	FOR i := 16 TO 1 BY -1 DO B40.ASRL_LF(20H); B.PAUSE(5) END;
	FOR i := 16 TO 1 BY -1 DO B40.ASRL_UP(31H); B.PAUSE(5) END;
	FOR i := 6 TO 1 BY -1 DO B40.ASRL_RG(29H); B.PAUSE(5) END;
	FOR i := 5 TO 1 BY -1 DO B40.ASRL_DN(17H); B.PAUSE(5) END;

	FOR i := 31H TO 71H DO B40.AREPLC(i, i+1); B.PAUSE(5) END;
	B40.ACHANGE(0F7H, 1);

	FOR i := 127 TO 1 BY -2 DO B40.PFIGURE(i*2, i, "065088060") END;
	FOR i := 127 TO 1 BY -2 DO B40.PFIGURE(i*2, i+10, "065088060") END;

	FOR i := 16 TO 1 BY -1 DO
		B40.SSRL_LF; B40.SSRL_UP; B40.SSRL_RG; B40.SSRL_DN;
	END;

	FOR i := 99 TO 1 BY -2 DO B40.PFIGURE(i*2, i+26, "06050808060") END;

	B40.ASRL_RG(04H + 23H);
	B40.ASRL_DN(04H + 25H);

	FOR i := 10 TO 1 BY -1 DO B40.SCR_INV END;

	B40.PAINT(0, 0);
	FOR i := 64 TO 1 BY -1 DO B40.PSRL_LF END;
	FOR i := 32 TO 1 BY -1 DO B40.PSRL_RG END;
	FOR i := 16 TO 1 BY -1 DO B40.PSRL_DN END;
	FOR i := 16 TO 1 BY -1 DO B40.PSRL_UP END;
	B40.SCR_INV; B40.SCR_INV;

	B40.SCR_MRG(0000H);

	B.DEFDATA(udg, 8*8);
	B.DATA8(01EH,036H,066H,066H,07EH,066H,066H,000H);
	B.DATA8(07CH,060H,060H,07CH,066H,066H,07CH,000H);
	B.DATA8(07CH,066H,066H,07CH,066H,066H,07CH,000H);
	B.DATA8(07EH,060H,060H,060H,060H,060H,060H,000H);
	B.DATA8(038H,06CH,06CH,06CH,06CH,06CH,0FEH,0C6H);
	B.DATA8(07EH,060H,060H,07CH,060H,060H,07EH,000H);
	B.DATA8(0DBH,0DBH,07EH,03CH,07EH,0DBH,0DBH,000H);
	B.DATA8(03CH,066H,006H,01CH,006H,066H,03CH,000H);
	B.UDG(udg);
	B.PRUDG("A"); B.PRUDG("B"); B.PRUDG("C"); B.PRUDG("D");
	B.PRUDG("E"); B.PRUDG("F"); B.PRUDG("G"); B.PRUDG("H"); B.PRLN;
	FOR i := 0*8 TO 7*8 BY 8 DO B40.SINV_LR(udg + i) END;
	B.PRUDG("A"); B.PRUDG("B"); B.PRUDG("C"); B.PRUDG("D");
	B.PRUDG("E"); B.PRUDG("F"); B.PRUDG("G"); B.PRUDG("H"); B.PRLN;
	FOR i := 0*8 TO 7*8 BY 8 DO B40.SINV_UD(udg + i) END;
	B.PRUDG("A"); B.PRUDG("B"); B.PRUDG("C"); B.PRUDG("D");
	B.PRUDG("E"); B.PRUDG("F"); B.PRUDG("G"); B.PRUDG("H"); B.PRLN;
	FOR i := 0*8 TO 7*8 BY 8 DO B40.SINV_LR(udg + i) END;
	B.PRUDG("A"); B.PRUDG("B"); B.PRUDG("C"); B.PRUDG("D");
	B.PRUDG("E"); B.PRUDG("F"); B.PRUDG("G"); B.PRUDG("H"); B.PRLN;
	FOR i := 0*8 TO 7*8 BY 8 DO B40.SINV_UD(udg + i); B40.SROTATE(udg + i) END;
	B.PRUDG("A"); B.PRUDG("B"); B.PRUDG("C"); B.PRUDG("D");
	B.PRUDG("E"); B.PRUDG("F"); B.PRUDG("G"); B.PRUDG("H"); B.PRLN;
	FOR i := 0*8 TO 7*8 BY 8 DO B40.SROTATE(udg + i); B40.SROTATE(udg + i) END;
	B.PRUDG("A"); B.PRUDG("B"); B.PRUDG("C"); B.PRUDG("D");
	B.PRUDG("E"); B.PRUDG("F"); B.PRUDG("G"); B.PRUDG("H"); B.PRLN;

	B40.PSCALER(0, 0, 63, 47, 3, 3, 32, 48);

	B.BORDER(B.Olive); B.PAUSE(B.WaitAKey); B.Quit;
END Best40Test;

BEGIN (*$MAIN*)
  B.Init;
  IF PT3x0A.TabAdr() MOD 256 # 0 THEN
    B.PRSTR("Start address of module must be aligned to ");
    B.PRINT(PT3x0A.TabAdr() MOD 256); B.PRSTR(" bytes"); B.PAUSE(0);
  END;

  (* Player & melodies are from http://zxpress.ru/article.php?id=9508 *)
  B.DEFDATA(ace, 2137); (* ace.m *)
  B.DATA12(050H,072H,06FH,054H,072H,061H,063H,06BH,065H,072H,020H,033H);
  B.DATA12(02EH,036H,020H,063H,06FH,06DH,070H,069H,06CH,061H,074H,069H);
  B.DATA12(06FH,06EH,020H,06FH,066H,020H,061H,063H,065H,020H,020H,020H);
  B.DATA12(020H,020H,020H,020H,020H,020H,020H,020H,020H,020H,020H,020H);
  B.DATA12(020H,020H,020H,020H,020H,020H,020H,020H,020H,020H,020H,020H);
  B.DATA12(020H,020H,020H,062H,079H,020H,053H,063H,06CH,020H,028H,066H);
  B.DATA12(06FH,072H,020H,033H,062H,069H,074H,021H,029H,020H,020H,020H);
  B.DATA12(020H,020H,020H,020H,020H,020H,020H,020H,020H,020H,020H,020H);
  B.DATA12(020H,020H,020H,002H,006H,01BH,01AH,0E5H,000H,000H,000H,000H);
  B.DATA12(000H,000H,000H,000H,000H,036H,008H,000H,000H,000H,000H,000H);
  B.DATA12(000H,04CH,008H,000H,000H,000H,000H,000H,000H,000H,000H,000H);
  B.DATA12(000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H);
  B.DATA12(000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H);
  B.DATA12(000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H);
  B.DATA12(000H,052H,008H,000H,000H,000H,000H,055H,008H,000H,000H,000H);
  B.DATA12(000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H);
  B.DATA12(000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,009H,006H);
  B.DATA12(003H,003H,021H,021H,00CH,00FH,012H,012H,015H,018H,01BH,003H);
  B.DATA12(003H,021H,021H,00CH,00FH,012H,012H,015H,018H,01BH,01EH,024H);
  B.DATA12(0FFH,033H,001H,0A6H,001H,009H,002H,0ACH,002H,0A6H,001H,01EH);
  B.DATA12(003H,00DH,002H,0A6H,001H,07FH,002H,00DH,002H,0A6H,001H,009H);
  B.DATA12(002H,0ACH,002H,0A6H,001H,033H,004H,0ACH,002H,0C9H,004H,033H);
  B.DATA12(004H,02CH,005H,04BH,005H,033H,004H,002H,006H,04BH,005H,033H);
  B.DATA12(004H,0AFH,006H,09CH,007H,033H,004H,0AFH,006H,0BFH,007H,033H);
  B.DATA12(004H,0E7H,007H,0FBH,007H,01EH,008H,0ACH,002H,0A6H,001H,0A3H);
  B.DATA12(003H,032H,008H,032H,008H,032H,008H,0F3H,008H,0CEH,009H,0B1H);
  B.DATA12(002H,085H,006H,009H,087H,004H,009H,088H,006H,009H,08AH,004H);
  B.DATA12(009H,08CH,006H,0C9H,009H,08AH,004H,009H,08CH,006H,0C8H,009H);
  B.DATA12(08AH,004H,009H,08CH,006H,0C7H,009H,08AH,004H,009H,08CH,006H);
  B.DATA12(0C6H,009H,08AH,004H,009H,08CH,006H,0C5H,009H,08AH,004H,009H);
  B.DATA12(08CH,006H,0C4H,009H,08AH,004H,0CFH,009H,085H,006H,009H,087H);
  B.DATA12(004H,009H,088H,006H,009H,08AH,004H,009H,08CH,006H,0C9H,009H);
  B.DATA12(08AH,004H,009H,08CH,006H,0C8H,009H,08AH,004H,009H,08CH,006H);
  B.DATA12(0C7H,009H,08AH,004H,009H,08CH,006H,0C6H,009H,08AH,004H,009H);
  B.DATA12(08CH,006H,0C5H,009H,08AH,004H,009H,08CH,006H,0C4H,009H,08AH);
  B.DATA12(004H,000H,0F0H,010H,0CFH,0B1H,005H,079H,0CAH,0B1H,001H,0D0H);
  B.DATA12(0CFH,0B1H,005H,079H,0CAH,0B1H,001H,0D0H,0CFH,0B1H,003H,079H);
  B.DATA12(0CAH,0B1H,001H,0D0H,0CFH,0B1H,005H,077H,0CAH,0B1H,001H,0D0H);
  B.DATA12(0CFH,0B1H,005H,077H,0CAH,0B1H,001H,0D0H,0CFH,0B1H,003H,077H);
  B.DATA12(0CAH,0B1H,001H,0D0H,0CFH,0B1H,005H,072H,0CAH,0B1H,001H,0D0H);
  B.DATA12(0CFH,0B1H,005H,072H,0CAH,0B1H,001H,0D0H,0CFH,0B1H,003H,072H);
  B.DATA12(0CAH,0B1H,001H,0D0H,0CFH,0B1H,005H,074H,0CAH,0B1H,001H,0D0H);
  B.DATA12(0CFH,0B1H,005H,074H,0CAH,0B1H,001H,0D0H,0CFH,0B1H,003H,074H);
  B.DATA12(0CAH,0B1H,001H,0D0H,000H,0B1H,040H,0D0H,000H,0F3H,008H,0CEH);
  B.DATA12(009H,0B1H,002H,085H,006H,009H,087H,004H,009H,088H,006H,009H);
  B.DATA12(08AH,004H,009H,08CH,006H,0C9H,009H,08AH,004H,009H,08CH,006H);
  B.DATA12(0C8H,009H,08AH,004H,0CFH,009H,085H,006H,009H,087H,004H,009H);
  B.DATA12(088H,006H,009H,08AH,004H,009H,08CH,006H,0C9H,009H,08AH,004H);
  B.DATA12(009H,08CH,006H,0C8H,009H,08AH,004H,0CFH,009H,085H,006H,009H);
  B.DATA12(087H,004H,009H,088H,006H,009H,08AH,004H,009H,08CH,006H,0C9H);
  B.DATA12(009H,08AH,004H,009H,08CH,006H,0C8H,009H,08AH,004H,0CFH,009H);
  B.DATA12(08CH,006H,009H,08AH,004H,009H,087H,006H,009H,083H,004H,009H);
  B.DATA12(088H,006H,0C9H,009H,088H,004H,0CFH,009H,08FH,006H,0C9H,009H);
  B.DATA12(08FH,004H,000H,0B1H,038H,0D0H,0F0H,010H,0CDH,0B1H,001H,06DH);
  B.DATA12(001H,0D0H,001H,006H,000H,001H,0D0H,001H,006H,000H,001H,0D0H);
  B.DATA12(001H,007H,000H,001H,0D0H,001H,007H,000H,001H,0D0H,001H,007H);
  B.DATA12(000H,001H,0D0H,001H,006H,000H,001H,0D0H,001H,008H,000H,000H);
  B.DATA12(0F3H,008H,0CEH,009H,0B1H,002H,08CH,006H,009H,08AH,004H,009H);
  B.DATA12(088H,006H,009H,087H,004H,009H,085H,006H,0C9H,009H,087H,004H);
  B.DATA12(009H,085H,006H,0C8H,009H,087H,004H,0CFH,009H,085H,006H,009H);
  B.DATA12(087H,004H,009H,088H,006H,009H,08AH,004H,009H,08CH,006H,0C9H);
  B.DATA12(009H,08AH,004H,009H,08CH,006H,0C8H,009H,08AH,004H,0CFH,009H);
  B.DATA12(08CH,006H,009H,08AH,004H,009H,088H,006H,009H,087H,004H,009H);
  B.DATA12(085H,006H,0C9H,009H,087H,004H,009H,085H,006H,0C8H,009H,087H);
  B.DATA12(004H,0CFH,009H,08CH,006H,009H,08AH,004H,009H,087H,006H,009H);
  B.DATA12(083H,004H,009H,088H,006H,0C9H,009H,088H,004H,0CFH,009H,08FH);
  B.DATA12(006H,0C9H,009H,08FH,004H,000H,0F0H,008H,0CFH,0B1H,001H,061H);
  B.DATA12(0CAH,0D0H,0CFH,061H,0CAH,0D0H,0CFH,06DH,0CAH,0D0H,0CFH,0B1H);
  B.DATA12(003H,06DH,0CAH,0B1H,001H,0D0H,0CFH,061H,0CAH,0D0H,0CFH,06DH);
  B.DATA12(0CAH,0D0H,0CFH,06DH,0CAH,0D0H,0CFH,05FH,0CAH,0D0H,0CFH,05FH);
  B.DATA12(0CAH,0D0H,0CFH,06BH,0CAH,0D0H,0CFH,0B1H,003H,06BH,0CAH,0B1H);
  B.DATA12(001H,0D0H,0CFH,05FH,0CAH,0D0H,0CFH,06BH,0CAH,0D0H,0CFH,06BH);
  B.DATA12(0CAH,0D0H,0CFH,05AH,0CAH,0D0H,0CFH,05AH,0CAH,0D0H,0CFH,066H);
  B.DATA12(0CAH,0D0H,0CFH,0B1H,003H,066H,0CAH,0B1H,001H,0D0H,0CFH,05AH);
  B.DATA12(0CAH,0D0H,0CFH,066H,0CAH,0D0H,0CFH,066H,0CAH,0D0H,0CFH,05CH);
  B.DATA12(0CAH,0D0H,0CFH,05CH,0CAH,0D0H,0CFH,068H,0CAH,0D0H,0CFH,0B1H);
  B.DATA12(003H,068H,0CAH,0B1H,001H,0D0H,0CFH,05CH,0CAH,0D0H,0CFH,068H);
  B.DATA12(0CAH,0D0H,0CFH,068H,0CAH,0D0H,000H,0F0H,008H,0CFH,0B1H,001H);
  B.DATA12(061H,0CAH,0D0H,043H,0CFH,091H,0CAH,0D0H,040H,0CFH,06DH,0CAH);
  B.DATA12(0D0H,0CFH,0B1H,002H,06DH,043H,091H,040H,0B1H,001H,061H,0CAH);
  B.DATA12(0D0H,0CFH,06DH,0CAH,0D0H,0CFH,06DH,0CAH,0D0H,0CFH,05FH,0CAH);
  B.DATA12(0D0H,043H,0CFH,0B1H,002H,091H,040H,0B1H,001H,06BH,0CAH,0D0H);
  B.DATA12(0CFH,0B1H,002H,06BH,043H,091H,040H,0B1H,001H,05FH,0CAH,0D0H);
  B.DATA12(0CFH,06BH,0CAH,0D0H,0CFH,06BH,0CAH,0D0H,0CFH,05AH,0CAH,0D0H);
  B.DATA12(043H,0CFH,0B1H,002H,091H,040H,0B1H,001H,066H,0CAH,0D0H,0CFH);
  B.DATA12(0B1H,002H,066H,043H,091H,040H,0B1H,001H,05AH,0CAH,0D0H,0CFH);
  B.DATA12(066H,0CAH,0D0H,0CFH,066H,0CAH,0D0H,0CFH,05CH,0CAH,0D0H,043H);
  B.DATA12(0CFH,0B1H,002H,08FH,040H,0B1H,001H,068H,0CAH,0D0H,0CFH,0B1H);
  B.DATA12(002H,068H,043H,08FH,040H,0B1H,001H,05CH,0CAH,0D0H,0CFH,068H);
  B.DATA12(0CAH,0D0H,0CFH,068H,0CAH,0D0H,000H,0F0H,008H,0CFH,0B1H,001H);
  B.DATA12(061H,0CAH,0D0H,043H,0CFH,091H,0CAH,0D0H,040H,0CFH,06DH,0CAH);
  B.DATA12(0D0H,0CFH,0B1H,002H,06DH,043H,091H,040H,0B1H,001H,061H,0CAH);
  B.DATA12(0D0H,043H,0CFH,0B1H,002H,094H,040H,0B1H,001H,06DH,0CAH,0D0H);
  B.DATA12(0CFH,05FH,0CAH,0D0H,043H,0CFH,091H,0CAH,0D0H,040H,0CFH,06BH);
  B.DATA12(0CAH,0D0H,0CFH,0B1H,002H,06BH,043H,091H,040H,0B1H,001H,05FH);
  B.DATA12(0CAH,0D0H,0CFH,06BH,0CAH,0D0H,0CFH,06BH,0CAH,0D0H,0CFH,05AH);
  B.DATA12(0CAH,0D0H,043H,0CFH,0B1H,002H,091H,040H,0B1H,001H,066H,0CAH);
  B.DATA12(0D0H,0CFH,0B1H,002H,066H,043H,091H,040H,0B1H,001H,05AH,0CAH);
  B.DATA12(0D0H,043H,0CFH,0B1H,002H,094H,040H,0B1H,001H,066H,0CAH,0D0H);
  B.DATA12(0CFH,05CH,0CAH,0D0H,043H,0CFH,0B1H,002H,08FH,040H,0B1H,001H);
  B.DATA12(068H,0CAH,0D0H,0CFH,0B1H,002H,068H,043H,08FH,040H,0B1H,001H);
  B.DATA12(05CH,0CAH,0D0H,0CFH,0B1H,002H,098H,0B1H,001H,068H,0CAH,0D0H);
  B.DATA12(000H,0F0H,010H,0CFH,0B1H,005H,079H,0CAH,0B1H,001H,0D0H,0CFH);
  B.DATA12(0B1H,005H,079H,0CAH,0B1H,001H,0D0H,0CFH,0B1H,003H,079H,0CAH);
  B.DATA12(0B1H,001H,0D0H,0CFH,0B1H,005H,07CH,0CAH,0B1H,001H,0D0H,0CFH);
  B.DATA12(0B1H,005H,07CH,0CAH,0B1H,001H,0D0H,0CFH,0B1H,003H,07CH,0CAH);
  B.DATA12(0B1H,001H,0D0H,0CFH,0B1H,005H,07EH,0CAH,0B1H,001H,0D0H,0CFH);
  B.DATA12(0B1H,005H,07EH,0CAH,0B1H,001H,0D0H,0CFH,0B1H,003H,07EH,0CAH);
  B.DATA12(0B1H,001H,0D0H,0CFH,0B1H,005H,080H,0CAH,0B1H,001H,0D0H,0CFH);
  B.DATA12(0B1H,005H,080H,0CAH,0B1H,001H,0D0H,0CFH,0B1H,003H,080H,0CAH);
  B.DATA12(0B1H,001H,0D0H,000H,0F3H,008H,0CFH,0B1H,004H,091H,096H,098H);
  B.DATA12(0CAH,098H,0CFH,098H,096H,091H,0CAH,091H,0CFH,091H,094H,098H);
  B.DATA12(0CAH,098H,0CFH,09BH,098H,094H,0B1H,002H,093H,094H,000H,0F0H);
  B.DATA12(010H,0CFH,009H,0B1H,002H,079H,006H,009H,0D0H,004H,009H,0B1H);
  B.DATA12(001H,0D0H,006H,0CAH,0D0H,0CFH,009H,0B1H,002H,079H,004H,009H);
  B.DATA12(0D0H,006H,009H,0B1H,001H,0D0H,004H,0CAH,0D0H,0CFH,009H,0B1H);
  B.DATA12(002H,079H,006H,009H,0B1H,001H,0D0H,004H,0CAH,0D0H,0CFH,009H);
  B.DATA12(0B1H,002H,07CH,006H,009H,0D0H,004H,009H,0B1H,001H,0D0H,006H);
  B.DATA12(0CAH,0D0H,0CFH,009H,0B1H,002H,07CH,004H,009H,0D0H,006H,009H);
  B.DATA12(0B1H,001H,0D0H,004H,0CAH,0D0H,0CFH,009H,0B1H,002H,07CH,006H);
  B.DATA12(009H,0B1H,001H,0D0H,004H,0CAH,0D0H,0CFH,009H,0B1H,002H,07EH);
  B.DATA12(006H,009H,0D0H,004H,009H,0B1H,001H,0D0H,006H,0CAH,0D0H,0CFH);
  B.DATA12(009H,0B1H,002H,07EH,004H,009H,0D0H,006H,009H,0B1H,001H,0D0H);
  B.DATA12(004H,0CAH,0D0H,0CFH,009H,0B1H,002H,07EH,006H,009H,0B1H,001H);
  B.DATA12(0D0H,004H,0CAH,0D0H,0CFH,009H,0B1H,002H,080H,006H,009H,0D0H);
  B.DATA12(004H,009H,0B1H,001H,0D0H,006H,0CAH,0D0H,0CFH,009H,0B1H,002H);
  B.DATA12(080H,004H,009H,0D0H,006H,009H,0B1H,001H,0D0H,004H,0CAH,0D0H);
  B.DATA12(0CFH,009H,0B1H,002H,080H,006H,009H,0B1H,001H,0D0H,004H,0CAH);
  B.DATA12(0D0H,000H,0F3H,008H,0CFH,0B1H,002H,091H,040H,0B1H,001H,06DH);
  B.DATA12(0CAH,0D0H,043H,0CFH,0B1H,002H,096H,040H,0B1H,001H,06DH,0CAH);
  B.DATA12(0D0H,043H,0CFH,0B1H,002H,098H,040H,0B1H,001H,079H,0CAH,0D0H);
  B.DATA12(043H,0B1H,002H,098H,040H,0CFH,0B1H,001H,074H,0CAH,0D0H,043H);
  B.DATA12(0CFH,0B1H,002H,098H,040H,0B1H,001H,06DH,0CAH,0D0H,043H,0CFH);
  B.DATA12(0B1H,002H,096H,040H,0B1H,001H,06DH,0CAH,0D0H,043H,0CFH,0B1H);
  B.DATA12(002H,091H,040H,0B1H,001H,079H,0CAH,0D0H,043H,0B1H,002H,091H);
  B.DATA12(040H,0CFH,0B1H,001H,074H,0CAH,0D0H,043H,0CFH,0B1H,002H,091H);
  B.DATA12(040H,0B1H,001H,06DH,0CAH,0D0H,043H,0CFH,0B1H,002H,094H,040H);
  B.DATA12(0B1H,001H,06DH,0CAH,0D0H,043H,0CFH,0B1H,002H,098H,040H,0B1H);
  B.DATA12(001H,079H,0CAH,0D0H,043H,0B1H,002H,098H,040H,0CFH,0B1H,001H);
  B.DATA12(074H,0CAH,0D0H,043H,0CFH,0B1H,002H,09BH,040H,0B1H,001H,06DH);
  B.DATA12(0CAH,0D0H,043H,0CFH,0B1H,002H,098H,040H,0B1H,001H,06DH,0CAH);
  B.DATA12(0D0H,043H,0CFH,0B1H,002H,094H,040H,0B1H,001H,079H,0CAH,0D0H);
  B.DATA12(043H,0CFH,0B1H,002H,093H,094H,000H,0F3H,008H,0CFH,009H,0B1H);
  B.DATA12(002H,091H,006H,040H,009H,0B1H,001H,06DH,004H,0CAH,0D0H,043H);
  B.DATA12(0CFH,009H,0B1H,002H,096H,006H,040H,009H,0B1H,001H,06DH,004H);
  B.DATA12(0CAH,0D0H,043H,0CFH,009H,0B1H,002H,098H,006H,040H,009H,0B1H);
  B.DATA12(001H,079H,004H,0CAH,0D0H,043H,009H,0B1H,002H,098H,006H,040H);
  B.DATA12(0CFH,009H,0B1H,001H,074H,004H,0CAH,0D0H,043H,0CFH,009H,0B1H);
  B.DATA12(002H,098H,006H,040H,009H,0B1H,001H,06DH,004H,0CAH,0D0H,043H);
  B.DATA12(0CFH,009H,0B1H,002H,096H,006H,040H,009H,0B1H,001H,06DH,004H);
  B.DATA12(0CAH,0D0H,043H,0CFH,009H,0B1H,002H,091H,006H,040H,009H,0B1H);
  B.DATA12(001H,079H,004H,0CAH,0D0H,043H,009H,0B1H,002H,091H,006H,040H);
  B.DATA12(0CFH,009H,0B1H,001H,074H,004H,0CAH,0D0H,043H,0CFH,009H,0B1H);
  B.DATA12(002H,091H,006H,040H,009H,0B1H,001H,06DH,004H,0CAH,0D0H,043H);
  B.DATA12(0CFH,009H,0B1H,002H,094H,006H,040H,009H,0B1H,001H,06DH,004H);
  B.DATA12(0CAH,0D0H,043H,0CFH,009H,0B1H,002H,098H,006H,040H,009H,0B1H);
  B.DATA12(001H,079H,004H,0CAH,0D0H,043H,009H,0B1H,002H,098H,006H,040H);
  B.DATA12(0CFH,009H,0B1H,001H,074H,004H,0CAH,0D0H,043H,0CFH,009H,0B1H);
  B.DATA12(002H,09BH,006H,040H,009H,0B1H,001H,06DH,004H,0CAH,0D0H,043H);
  B.DATA12(0CFH,009H,0B1H,002H,098H,006H,040H,009H,0B1H,001H,06DH,004H);
  B.DATA12(0CAH,0D0H,043H,0CFH,009H,0B1H,002H,094H,006H,040H,009H,0B1H);
  B.DATA12(001H,079H,004H,0CAH,0D0H,043H,0CFH,009H,0B1H,002H,093H,006H);
  B.DATA12(009H,094H,004H,000H,0F0H,008H,0CFH,0B1H,004H,06DH,079H,0B1H);
  B.DATA12(008H,077H,0B1H,004H,06DH,079H,0B1H,008H,077H,0B1H,004H,06DH);
  B.DATA12(079H,0B1H,008H,077H,0B1H,004H,06DH,079H,0B1H,006H,077H,0B1H);
  B.DATA12(002H,074H,000H,0F0H,008H,0CFH,0B1H,004H,06DH,079H,0B1H,008H);
  B.DATA12(077H,0B1H,004H,06DH,079H,0B1H,008H,077H,0B1H,004H,06DH,079H);
  B.DATA12(0B1H,008H,077H,043H,0CEH,0B1H,002H,08CH,08AH,087H,083H,088H);
  B.DATA12(0CAH,088H,0CFH,08FH,0CAH,08FH,000H,0F3H,008H,0CFH,0B1H,002H);
  B.DATA12(08CH,0C9H,08CH,0C7H,08CH,0C5H,08CH,0C3H,08CH,0C2H,08CH,0C1H);
  B.DATA12(08CH,0C0H,000H,0F0H,010H,0CBH,009H,0B1H,002H,079H,006H,0C9H);
  B.DATA12(009H,079H,004H,0C7H,009H,079H,006H,0C5H,009H,079H,004H,0C3H);
  B.DATA12(009H,079H,006H,0C1H,009H,079H,004H,009H,0C0H,006H,009H,0D0H);
  B.DATA12(004H,000H,0F0H,008H,0CFH,0B1H,002H,061H,0C9H,061H,0C7H,061H);
  B.DATA12(0C5H,061H,0C3H,061H,0C2H,061H,0C1H,061H,0C0H,000H,0B1H,004H);
  B.DATA12(0D0H,000H,003H,005H,001H,08FH,000H,000H,001H,08FH,000H,000H);
  B.DATA12(001H,08FH,000H,000H,001H,08DH,000H,000H,081H,08DH,000H,000H);
  B.DATA12(000H,001H,000H,08DH,000H,000H,000H,001H,000H,001H,002H,00CH);
  B.DATA1 (000);

  PT3x0A.Install(ace);

  B.IM2PROC(ProcIM2);

  (*B.OVER(B.On); LOOP B.PLOT(B.RND(0, 255), B.RND(0, 175)) END;*)

  Best40Test;

  PT3x0A.Stop; B.Quit;
END TestPT3IM2.
